<?php
/*
Name: Peter's Custom Anti-Spam for input forms
URL: http://www.theblog.ca/anti-spam-input
Description: Stop a lot of spambots from polluting your site by making visitors identify a random word displayed as an image before commenting. You can customize the pool of words to display. This is based on the same plugin for WordPress at http://www.theblog.ca/anti-spam
Author: Peter Keung
Version: 1.1
Instructions: See readme.txt
*/

// -----------------------------------------------------------------------------------

$cas_text = array(); // <-- This line should not be changed
// List as many words as you like, one per line
// If you want some words to be used more often, enter them multiple times.
// It is best to use words that are eight letters or less
$cas_text[] = 'help';
$cas_text[] = 'corner';
$cas_text[] = 'heavy';
$cas_text[] = 'come';
$cas_text[] = 'down';
$cas_text[] = 'just';
$cas_text[] = 'heart';
$cas_text[] = 'matter';
$cas_text[] = 'rescue';
$cas_text[] = 'for';

$cas_fontlist = array(); // <-- This line should not be changed
// List as many TrueType font(s) as you like, one per line. Drop your own font files into this plugin's directory.
// If you are using your own fonts, make sure all fonts used are about the same default size.
// If you want some fonts to be used more frequently, enter them multiple times.
// Default freeware fonts from font101.com
$cas_fontlist[] = "04b03.ttf";
$cas_fontlist[] = "baileysansitcbook.ttf";
$cas_fontlist[] = "decorative-stylisticblackout-regular.ttf";
$cas_fontlist[] = "okrienhmk.ttf";
$cas_fontlist[] = "pointed.ttf";
$cas_fontlist[] = "typoderm.ttf";

// Set the anti-spam image width and height.
// You may need to increase these sizes for longer words and/or bigger fonts.
$cas_imgwidth = 160;
$cas_imgheight = 50;

// Set this to TRUE if you want to use random text colors.
// If random colors are not selected, blue text will appear on a white background, and white text will appear on black background (as decided in the next option)
$cas_randomcolors = true;

// Set the background color for the anti-spam image.
// Choose either "black" or "white"
$cas_bgcolorset = "white";

// Set the border color for the anti-spam image.
// Write either major colors (red, green, blue, etc.) or enter the HTML color code (such as #C0C0C0)
$cas_borderclr = "black";

// Set this to TRUE if you prefer PNG graphics (better quality text)
// Set this to FALSE if you prefer more compatable graphics (PNG crashes IE 4; JPEG does not)
$cas_UsePngNotJpeg = false;

// Set this to TRUE to enable wav files of the anti-spam words so that visually enabled users can comment
$cas_wav = true;

// Set this to FALSE if you know that your server doesn't have the sox filter or if you do not want to stretch the audio files by a variable rate
$cas_sox = true;

// Set this to be the URL path to this file from your input form. Leave this empty if the files that will include this file reside in the same directory
$cas_siteurl = '';

// Set this to the absolute path to the folder that holds this file (something like '/home/public_html/yoursite/'. You can leave this empty if the files that will include this file reside in the same directory
$cas_absolutepath = '';

// -----------------------------------------------------------------------------------
// Translation stuff. If your blog is in a different language, edit these fields to suit your language!
$cas_displaytext = array(); // <-- This line should not be changed

// This is the name of the label for the comment form
$cas_displaytext['label'] = 'Anti-spam word: (Required)';

// These are the instructions for filling in the anti-spam word in the comment form
$cas_displaytext['instructions'] = 'To prove you\'re a person (not a spam script), type the security word shown in the picture.';

if ($cas_wav) {
// Additional instructions for the audio-impaired users
$cas_displaytext['instructions'] .= ' Click on the picture to hear an audio file of the word.';
}

// Error message if someone has not typed anything into the anti-spam field
$cas_displaytext['emptyfield'] = 'Error: Please enter the anti-spam word.';

// Error message if the particular anti-spam image has already been used on a comment
$cas_displaytext['alreadyused'] = 'Error: The anti-spam word is invalid. Please report this error to the webmaster. Go back and refresh the page to re-submit your comment.';

// Error message if someone has typed the wrong word into the anti-spam field
$cas_displaytext['wrongfield'] = 'Error: Please enter the correct anti-spam word. Press the back button and try again.';

// Error message when trying to generate an audio file and the anti-spam image has already been used
$cas_displaytext['not_valid'] = 'That anti-spam number is no longer valid.';

// Text to show in an invalid image
$cas_displaytext['invalid'] = '* * * INVALID * * *';

// Error message if the GD Library is not installed
$cas_displaytext['no_gd'] = 'Cannot initialize new GD image stream';

if (!$cas_wav) {
// Text for the normal alt tag of the image
$cas_displaytext['alt_tag'] = 'Anti-spam image';
}
else {
// Text for the alt tag of the image for visually impaired users
$cas_displaytext['alt_tag'] = 'Click to hear an audio file of the anti-spam word';
}

// -----------------------------------------------------------------------------------
// You should not need to (and probably shouldn't) edit anything from here to the end.

// Folder that the fonts are held in, relative to this file. Include a trailing slash
$cas_fontpath = 'fonts/';

// Folder that the sounds are held in, relative to this file. Include a trailing slash.
$cas_soundpath = 'sounds/';

// Folder that the temporary sounds will be held, relative to this file. Include a trailing slash.
// This folder must be writeable
$cas_tempsounds = 'temp_sounds/';

// This makes it so that the invalid audio file pages are not indexed by search engines
$cas_displaytext['not_valid'] = '<html><head><title>' . $cas_displaytext['not_valid'] . '</title><meta name="Robots" content="noindex,nofollow"></head><body>' . $cas_displaytext['not_valid'] . '</body></html>';

// Determine how many words were entered
$cas_textcount = count( $cas_text );
// Copy the first element to a new last element
$cas_text[] = $cas_text[0];
// Set the first element to invalid
$cas_text[0] = "* * * INVALID * * *";

// Include the database connection information
include $cas_absolutepath . 'cas_db.php';

// Output the antispam audio file
if( isset( $_GET['audioselect'] ) )
{
	// Include the wav merging class
	include $cas_absolutepath . $cas_soundpath . 'wav_join.php';

	// Validate the input values
	$cas_audioselect = intval( $_GET['audioselect'] );

	// Get the word from the database
	$cas_antispam = mysql_query('SELECT word FROM ' . $cas_table_words . ' WHERE id = ' . $cas_audioselect);
    if (mysql_num_rows($cas_antispam) == 0) die($cas_displaytext['not_valid']);
    $cas_antispam_result = mysql_result($cas_antispam, 0);


	// Get the word
	$petersword = strtolower($cas_antispam_result);

	// Strip out spaces and hyphens
	$petersword = str_replace(array('-',' '), array('',''), $petersword);

	// Count the number of letters in the word
	$word_count = strlen($petersword);

	// Write the function str_split if it doesn't exist (in PHP 4)
	if (!function_exists('str_split')) {
		function str_split($string) {
			global $word_count;
			$letters = array();
			for ($i = 0; $i < $word_count; ++$i) {
				$letters[$i] = substr($string, $i, 1);
			}
			return $letters;
		}
	}

	// Split the word into an array of individual letters
	$cas_wavs = str_split($petersword);

	// Merge the wav files for this word
	$cas_one_wav = joinwavs($cas_wavs);

	// Create a temporary file for this word
	$cas_audioinput = tempnam($cas_absolutepath . $cas_tempsounds, 'cas_');
	$cas_audiooutput = $cas_audioinput . '1.wav';
	$cas_handle=fopen($cas_audioinput, "w");
	fwrite($cas_handle, $cas_one_wav);
	fclose($cas_handle);

	// Clear the variable out since the sound is now in a temporary file
	unset($cas_one_wav);

    if ($cas_sox) {
        // Make use of the sox filter, if available, to make it hard for bots to crack the audio file

        // This will determine a stretch factor with 20 different possibilities
        $stretch_random = sprintf("%02d", rand( 0, 20));

        // Stretch the audio file
        @exec('sox ' . $cas_audioinput . ' ' . $cas_audiooutput . ' stretch 1.' . $stretch_random . ' > /dev/null 2>&1');
    }
    
	// If the sox filter was available, use the stretched file. Otherwise, use the original file
	if (file_exists($cas_audiooutput)) {
		$cas_one_wav = file_get_contents($cas_audiooutput);
	}
	else {
		$cas_one_wav = file_get_contents($cas_audioinput);
	}

	// Spit it the file out to the browser	
	output('output.wav', $cas_one_wav);

	// Delete the files
	if (file_exists($cas_audioinput)) unlink($cas_audioinput);
	if (file_exists($cas_audiooutput)) unlink($cas_audiooutput);

	// Prevent any more display to the page
	die();
}

// Output the antispam image
elseif( isset( $_GET['antiselect'] ) )
{
	// Pick a random font to use
	$cas_font = $cas_absolutepath . $cas_fontpath . $cas_fontlist[ rand( 0, count( $cas_fontlist ) - 1 ) ];

	// Set the default colors for when random text colors are not selected
	if ( $cas_bgcolorset == "white") {
	$cas_textcolor = array( 0, 0, 255 ); // blue text
	$cas_bgcolor = array( 255, 255, 255); // white background
	}
	else {
	$cas_textcolor = array( 255, 255, 255 ); // white text
	$cas_bgcolor = array( 0, 0, 0); // black background
	}

	// If selected, pick a random color for the antispam word text
	if( $cas_randomcolors )
	{
		$cas_rand = rand( 0, 4 );
		switch( $cas_bgcolorset )
			{
				case "white":
					$cas_textcolorchoice[0] = array ( 0, 0, 255 ); // blue
					$cas_textcolorchoice[1] = array ( 0, 153, 0 ); // greenish
					$cas_textcolorchoice[2] = array ( 204, 0, 0 ); // reddish
					$cas_textcolorchoice[3] = array ( 203, 0, 154 ); // purplish
					$cas_textcolorchoice[4] = array ( 0, 0, 0 ); // black
					$cas_textcolor = $cas_textcolorchoice[$cas_rand];
					break;
				default:
					$cas_textcolorchoice[0] = array ( 255, 255, 0 ); // yellow
					$cas_textcolorchoice[1] = array ( 0, 255, 255 ); // blueish
					$cas_textcolorchoice[2] = array ( 255, 153, 204 ); // pinkish
					$cas_textcolorchoice[3] = array ( 102, 255, 102 ); // greenish
					$cas_textcolorchoice[4] = array ( 255, 255, 255 ); // white
					$cas_textcolor = $cas_textcolorchoice[$cas_rand];
					break;
			}
	}

	// Validate the input values
	$cas_antiselect = intval( $_GET['antiselect'] );
    
	// Get the word from the database
	$cas_antispam = mysql_query('SELECT word FROM ' . $cas_table_words . ' WHERE id = ' . $cas_antiselect);
	if (mysql_num_rows($cas_antispam) == 0) {
        $cas_antispam_result = $cas_displaytext['invalid'];
    }
    else {
        $cas_antispam_result = mysql_result($cas_antispam, 0);
    }

	// Start building the image
	$cas_image = @imagecreate( $cas_imgwidth, $cas_imgheight ) or die($cas_displaytext['no_gd']);
	$cas_bgcolor = imagecolorallocate( $cas_image, $cas_bgcolor[0], $cas_bgcolor[1], $cas_bgcolor[2] );
	$cas_fontcolor = imagecolorallocate( $cas_image, $cas_textcolor[0], $cas_textcolor[1], $cas_textcolor[2] );

	// Check for freetype lib, if not found default to ugly built in capability using imagechar (Lee's mod)
	// Also check that the chosen TrueType font is available
	if( function_exists( 'imagettftext' ) && file_exists( $cas_font ) )
	{
		$cas_angle = 4; // Degrees to tilt the text
		$cas_offset = 10; // Pixels to offset the text from the border
		$cas_fontsize = 28; // Default font size for the anti-spam image
		$cas_imagebox = imagettfbbox($cas_fontsize, $cas_angle, $cas_font, $cas_antispam_result);
		$cas_boxwidth = $cas_imagebox[2] - $cas_imagebox[0];
		$cas_boxheight = $cas_imagebox[1] - $cas_imagebox[7];
		
		// if the text width is too big for the image, decrease the font size to a certain extent (best practice is of course not to use really long words!
		while ($cas_boxwidth > $cas_imgwidth - $cas_offset && $cas_fontsize > 12) {
			$cas_fontsize = $cas_fontsize - 3;
			$cas_imagebox = imagettfbbox($cas_fontsize, $cas_angle, $cas_font, $cas_antispam_result);
			$cas_boxwidth = $cas_imagebox[2] - $cas_imagebox[0];
		}

		// if the text height too big for the image, decrease the font size to a certain extent (best practice is of course not to use really long words!
		while ($cas_boxheight > $cas_imgheight - $cas_offset && $cas_fontsize > 12) {
			$cas_fontsize = $cas_fontsize - 3;
			$cas_imagebox = imagettfbbox($cas_fontsize, $cas_angle, $cas_font, $cas_antispam_result);
			$cas_boxheight = $cas_imagebox[1] - $cas_imagebox[7];
		}

		// Use png is available, since it produces clearer text images
		if( function_exists( 'imagepng' ) && $cas_UsePngNotJpeg )
		{
			imagettftext( $cas_image, $cas_fontsize, $cas_angle, $cas_offset, $cas_imgheight - $cas_offset, $cas_fontcolor, $cas_font, $cas_antispam_result );
			header( "Content-type: image/png" );
			imagepng( $cas_image );
		} else {
			imagettftext( $cas_image, $cas_fontsize, $cas_angle, $cas_offset, $cas_imgheight - $cas_offset, $cas_fontcolor, $cas_font, $cas_antispam_result );
			header( "Content-type: image/jpeg" );
			imagejpeg( $cas_image );
		}
	} else {
		$cas_fontsize = 5; // 1, 2, 3, 4 or 5 (higher numbers correspond to larger font sizes)
		$tmp_len = strlen( $cas_antispam_result );
		for( $tmp_count = 0; $tmp_count < $tmp_len; $tmp_count++ )
		{
		   $tmp_xpos = $tmp_count * imagefontwidth( $cas_fontsize ) + 20;
		   $tmp_ypos = 10;
		   imagechar( $cas_image, $cas_fontsize, $tmp_xpos, $tmp_ypos, $cas_antispam_result, $cas_fontcolor );
		   $cas_antispam = substr( $cas_antispam_result, 1);   
		}
		header("Content-Type: image/gif");
		imagegif( $cas_image );
	} // end if
	imagedestroy( $cas_image );
	die();
} else {
	function cas_comment_form()
	{
		global $cas_textcount, $cas_text, $cas_siteurl, $cas_imgheight, $cas_imgwidth, $cas_limitcolor, $cas_borderclr, $cas_message, $cas_displaytext, $cas_table_words, $cas_table_count, $cas_wav;

		// Insert a row into the count database to generate an auto_increment number
		mysql_query('INSERT INTO ' . $cas_table_count . ' (id) VALUES (NULL)');

		// Get the id of the inserted count to feed to the word table and image generator
		$cas_rowid_query = mysql_query('SELECT last_insert_id()');
        $cas_rowid = mysql_result($cas_rowid_query,0);
        
		// Pick a random number
		$cas_antiselect = rand( 1, $cas_textcount ); // 0 is for invalid, so don't select it

		// Put the word corresponding to the random number into the database
		mysql_query('INSERT INTO ' . $cas_table_words . ' (id, createtime, word) VALUES (' . $cas_rowid . ', ' . time() . ', \'' . $cas_text[$cas_antiselect] . '\')');

		// Delete the row from the count table
		mysql_query('DELETE FROM ' . $cas_table_count . ' WHERE id = ' . $cas_rowid);

		// Do some table admin while we can :D
		if (strlen($cas_rowid) == 10) {

			// Delete all rows from the count table
			mysql_query('DELETE FROM ' . $cas_table_count);

			// Reset the table's auto increment if it's getting too huge
			mysql_query('ALTER TABLE ' . $cas_table_count . ' AUTO_INCREMENT=1');

			// Delete any anti-spam words more than a day old
			mysql_query('DELETE FROM ' . $cas_table_words . ' WHERE ' . time() . ' > createtime + 86400');
		}

		echo( "\t\t\t".'<div style="display:block;" id="secureimgdiv">'."\n\t\t\t\t" );
		echo( "<p><label for=\"securitycode\">{$cas_displaytext['label']}</label><span style=\"color:#FF0000;\">*</span><br />\n\t\t\t\t" );
		echo( $cas_message . "<br />\n\t\t\t\t" );
		echo( '<input type="text" name="securitycode" id="securitycode" size="30" tabindex="4" />'."\n\t\t\t\t" );
		echo( '<input type="hidden" name="matchthis" value="' . $cas_rowid . "\" />\n\t\t\t\t" );
		if ($cas_wav) echo( '<a href="' . $cas_siteurl . 'cas_engine.php?audioselect=' . $cas_rowid . '" rel="nofollow" title="' . $cas_displaytext['alt_tag'] . '">' . "\n\t\t\t\t" );
		echo( '<img src="' . $cas_siteurl . 'cas_engine.php?antiselect=' . $cas_rowid . '" ' );
		echo( 'alt="' . $cas_displaytext['alt_tag'] . '" ' );
		echo( 'style="border:1px solid ' . $cas_borderclr . ';vertical-align:top;' );
		echo( 'height:' . $cas_imgheight .'px;width:' . $cas_imgwidth . 'px;" />' );
		if ($cas_wav) echo( '</a>');
		echo( "</p>\n\t\t\t" );
		echo( "</div>\n\t\t\t" );
	}

		function cas_comment_post()
		{
		global $_POST, $cas_text, $cas_textcount, $cas_displaytext, $cas_table_words;
		// Validate the form input values
		if( isset( $_POST['securitycode'] ) )
		{
			// Consider only the first 50 characters in the posted word
			$securitycode = substr( strval( $_POST['securitycode'] ), 0, 50 );

			// Remove all spaces and hyphens to give the commenter a break!
			$securitycode = str_replace(' ', '', $securitycode);
			$securitycode = str_replace('-', '', $securitycode);

		} else {
			$securitycode = '';
		}
		if( isset( $_POST['matchthis'] ) )
		{
			$matchnum = intval( $_POST['matchthis'] );
		} else {
			$matchnum = 0;
		}

		if ( $securitycode == '' )
		{
			die("<p>{$cas_displaytext['emptyfield']}</p>");
		}

		// Get the anti-spam word from the database
		$matchthis_query = mysql_query('SELECT word FROM ' . $cas_table_words . ' WHERE id = ' . $matchnum);
        
        // If this row doesn't exist, say something
		if (mysql_num_rows($matchthis_query) == 0) die("<p>{$cas_displaytext['alreadyused']}</p>");
        
        // Grab the word otherwise
        $matchthis = mysql_result($matchthis_query, 0);

		// Remove all spaces and hyphens, since we removed them from what the commenter entered
		$matchthis = str_replace(' ', '', $matchthis);
		$matchthis = str_replace('-', '', $matchthis);

		if ( strtolower( $matchthis ) != strtolower( $securitycode ) )
		{
			die("<p>{$cas_displaytext['wrongfield']}</p>");
		} else {
			// The word matched, so delete the row for the anti-spam word so that it cannot be used again
			mysql_query('DELETE FROM ' . $cas_table_words . ' WHERE id = ' . $matchnum);
			unset( $matchthis );

			// Do some more table admin while we can :D
			// Delete any anti-spam words more than a day old
			mysql_query('DELETE FROM ' . $cas_table_words . ' WHERE ' . time() . ' > createtime + 86400');
		}
	}
}
?>